<?php
/**
 * Created by PhpStorm.
 * User: jderosa
 * Date: 28/02/20
 * Time: 13.04
 */
namespace FiloBlu\Rma\Block\Order;
use Magento\Quote\Model\QuoteRepository;



class Totals extends \Magento\Sales\Block\Order\Totals
{
    /**
     * @var QuoteRepository
     */
    protected $quoteRepository;

    /**
     * Totals constructor.
     * @param \Magento\Framework\View\Element\Template\Context $context
     * @param \Magento\Framework\Registry $registry
     * @param QuoteRepository $quoteRepository
     * @param array $data
     */
    public function __construct(\Magento\Framework\View\Element\Template\Context $context,
                                \Magento\Framework\Registry $registry,
                                QuoteRepository $quoteRepository,
                                array $data = [])
    {
        parent::__construct($context, $registry, $data);
        $this->quoteRepository = $quoteRepository;
    }

    /**
     * @param null $area
     * @return array
     */
    public function getTotals($area = null)
    {
        try{
            $order = $this->getOrder();
            if($order->getQuoteId() && $order->getPayment()->getMethod()==\FiloBlu\Rma\Model\Payment\ChangeSizePay::PAYMENT_CODE){
                return $this->_totals;
            }
            $totals = [];
            if ($area === null) {
                $totals = $this->_totals;
            } else {
                $area = (string)$area;
                foreach ($this->_totals as $total) {
                    $totalArea = (string)$total->getArea();
                    if ($totalArea == $area) {
                        $totals[] = $total;
                    }
                }
            }
            return $totals;
        }catch (\Exception $e){
            $this->_logger->critical($e->getMessage());
            return $this->_totals;
        }

    }

}