<?php
/**
 * Created by PhpStorm.
 * User: jderosa
 * Date: 04/11/19
 * Time: 0.42
 */

namespace FiloBlu\Rma\Plugin\Model;
use FiloBlu\Rma\Plugin\Block\Form\Renderer\Select;
use FiloBlu\Rma\Helper\ChangeSizeAttributeHelper;
use Magento\Framework\App\RequestInterface;
use Magento\Rma\Api\RmaRepositoryInterface;

class HideChangeSizeResolution
{

    /**
     * @var ChangeSizeAttributeHelper
     */
    protected $changeSizeAttributeHelper;

    /**
     * @var Select
     */
    protected $select;

    /**
     * @var RequestInterface
     */
    protected $requestInterface;

    /**
     * @var RmaRepositoryInterface
     */
    protected $rmaRepositoryInterface;

    /**
     * HideChangeSizeResolution constructor.
     * @param Select $select
     * @param ChangeSizeAttributeHelper $changeSizeAttributeHelper
     * @param RequestInterface $request
     * @param RmaRepositoryInterface $rmaRepository
     */
    public function __construct(Select $select,
                                ChangeSizeAttributeHelper $changeSizeAttributeHelper,
                                RequestInterface $request,
                                RmaRepositoryInterface $rmaRepository){
        $this->select = $select;
        $this->changeSizeAttributeHelper = $changeSizeAttributeHelper;
        $this->requestInterface = $request;
        $this->rmaRepositoryInterface = $rmaRepository;
    }

    /**
     * @param \Magento\Rma\Helper\Eav $subject
     * @param $result
     * @return array
     */
    public function afterGetAttributeOptionValues(\Magento\Rma\Helper\Eav $subject, $result){

        $allOptions = $result;
        $allowed = [];
        $pathInfo = $this->requestInterface->getPathInfo();
        if(stristr($pathInfo,'admin/rma/edit')){
            $rmaId = $this->requestInterface->getParam('id');
            $rma = $this->rmaRepositoryInterface->get($rmaId);
            $storeId = $rma->getStoreId();
        }else{
            $storeId = null;
        }
        if(!$this->select->changeSizeIsEnabled($storeId)){
            foreach ($result as $key => $options){
                if(!in_array($options,[$this->changeSizeAttributeHelper->getChangeSizeLabelByStoreId(0)]) && !in_array($options,[$this->changeSizeAttributeHelper->getChangeSizeLabelByStoreId($storeId)])){
                    $allowed [$key]= $options;
                }
            }
            $result = $allowed;
        }
        return $result;
    }

}